﻿using System.Collections.Generic;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;

namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
  public interface ISymbolicDataAnalysisSolutionImpactValuesCalculator {
    Dictionary<ISymbolicExpressionTreeNode, double> CalculateReplacementValues(ISymbolicExpressionTree tree,
                                                                               ISymbolicDataAnalysisExpressionTreeInterpreter interpreter,
                                                                               IDataAnalysisProblemData problemData);
    Dictionary<ISymbolicExpressionTreeNode, double> CalculateImpactValues(ISymbolicExpressionTree tree,
                                                                          ISymbolicDataAnalysisExpressionTreeInterpreter interpreter,
                                                                          IDataAnalysisProblemData problemData,
                                                                          double lowerEstimationLimit, double upperEstimationLimit);
  }
}
